## ros-iron-rcl-logging-spdlog 2.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl_logging_spdlog)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++17
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcl_logging_interface REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(spdlog_vendor REQUIRED) # Provides spdlog on platforms without it.
find_package(spdlog REQUIRED)

if(NOT WIN32)
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(
    -Wformat=2 -Wconversion -Woverloaded-virtual -Wshadow
    -Wnon-virtual-dtor -Wold-style-cast -Wcast-qual
  )
endif()

add_library(${PROJECT_NAME} src/rcl_logging_spdlog.cpp)
target_link_libraries(${PROJECT_NAME} PRIVATE
  rcpputils::rcpputils
  rcutils::rcutils
  spdlog::spdlog)
target_link_libraries(${PROJECT_NAME} PUBLIC
  rcl_logging_interface::rcl_logging_interface)

target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_LOGGING_INTERFACE_BUILDING_DLL")

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  # cppcheck 1.90 doesn't understand some of the syntax in spdlog's bundled fmt
  # code.  Since we already have cppcheck disabled on Linux, just disable it
  # completely for this package.
  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_cppcheck
  )
  ament_lint_auto_find_test_dependencies()

  find_package(performance_test_fixture REQUIRED)

  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gmock(test_logging_interface test/test_logging_interface.cpp)
  if(TARGET test_logging_interface)
    target_link_libraries(test_logging_interface ${PROJECT_NAME})
    target_compile_definitions(test_logging_interface PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
    ament_target_dependencies(test_logging_interface rcpputils)
  endif()
  add_performance_test(benchmark_logging_interface test/benchmark/benchmark_logging_interface.cpp)
  if(TARGET benchmark_logging_interface)
    target_link_libraries(benchmark_logging_interface ${PROJECT_NAME})
  endif()
endif()

ament_export_dependencies(rcl_logging_interface)
ament_export_dependencies(rcpputils)
ament_export_dependencies(rcutils)
ament_export_dependencies(spdlog_vendor)
ament_export_dependencies(spdlog)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_package()

=== debian/changelog ===
ros-iron-rcl-logging-spdlog (2.5.1-2jammy) jammy; urgency=high

  * Mark the benchmark _ as unused. (#99 <https://github.com/ros2/rcl_logging/issues/99>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 10 Apr 2023 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.5.0-2jammy) jammy; urgency=high

  * Update rcl_logging to C++17. (#98 <https://github.com/ros2/rcl_logging/issues/98>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 12 Feb 2023 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.4.3-2jammy) jammy; urgency=high

  * change flushing behavior for spdlog log files, and add env var to use old style (no explicit flushing) (#95 <https://github.com/ros2/rcl_logging/issues/95>)
    * now flushes every ERROR message and periodically every 5 seconds
    * can set ``RCL_LOGGING_SPDLOG_EXPERIMENTAL_OLD_FLUSHING_BEHAVIOR=1`` to get old behavior
  * Updated maintainers - 2022-11-07 (#96 <https://github.com/ros2/rcl_logging/issues/96>)
  * Contributors: Audrow Nash, William Woodall

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 17 Nov 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.4.2-2jammy) jammy; urgency=high

  * Disable cppcheck for rcl_logging_spdlog. (#93 <https://github.com/ros2/rcl_logging/issues/93>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 01 Nov 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.4.1-2jammy) jammy; urgency=high

  * ament_export_dependencies any package with targets we linked against (#89 <https://github.com/ros2/rcl_logging/issues/89>)
  * Contributors: Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 12 Sep 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.4.0-2jammy) jammy; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 28 Apr 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.3.0-2jammy) jammy; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 28 Feb 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.2.1-2jammy) jammy; urgency=high

  * Fix include order for cpplint (#84 <https://github.com/ros2/rcl_logging/issues/84>)
    Relates to https://github.com/ament/ament_lint/pull/324
  * Update maintainers to Chris Lalancette (#83 <https://github.com/ros2/rcl_logging/issues/83>)
  * Contributors: Audrow Nash, Jacob Perron

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 13 Jan 2022 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.2.0-2jammy) jammy; urgency=high

  * Fix renamed rcpputils header (#81 <https://github.com/ros2/rcl_logging/issues/81>)
  * Contributors: Abrar Rahman Protyasha

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 Nov 2021 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.1.3-2jammy) jammy; urgency=high

  * Update includes after rcutils/get_env.h deprecation (#75 <https://github.com/ros2/rcl_logging/issues/75>)
  * Contributors: Christophe Bedard

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 15 Sep 2021 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.1.2-2jammy) jammy; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#73 <https://github.com/ros2/rcl_logging/issues/73>)
  * Contributors: shonigmann

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 05 Apr 2021 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.1.1-2jammy) jammy; urgency=high

  * Include what you use (#71 <https://github.com/ros2/rcl_logging/issues/71>)
  * Contributors: Ivan Santiago Paunovic

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 24 Jan 2021 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.1.0-2jammy) jammy; urgency=high

  * Update QD to QL 1 (#66 <https://github.com/ros2/rcl_logging/issues/66>)
  * Make sure to check return value from external_initialize. (#65 <https://github.com/ros2/rcl_logging/issues/65>)
  * updated QD section 3.i and 3ii and spelling error (#63 <https://github.com/ros2/rcl_logging/issues/63>)
  * rcl_logging_spdlog: Increased QL to 2 in QD
  * Updated spdlog QL in QD
  * Make internal dependencies private (#60 <https://github.com/ros2/rcl_logging/issues/60>)
  * [rcl_logging_spdlog] Add warnings (#54 <https://github.com/ros2/rcl_logging/issues/54>)
  * Allow configuring logging directory through environment variables (#53 <https://github.com/ros2/rcl_logging/issues/53>)
  * Update the maintainers. (#55 <https://github.com/ros2/rcl_logging/issues/55>)
  * Added benchmark test to rcl_logging_spdlog (#52 <https://github.com/ros2/rcl_logging/issues/52>)
  * Used current_path() function from rcpputils (#51 <https://github.com/ros2/rcl_logging/issues/51>)
  * Add fault injection unittest to increase coverage (#49 <https://github.com/ros2/rcl_logging/issues/49>)
  * Contributors: Alejandro Hernández Cordero, Audrow Nash, Chris Lalancette, Christophe Bedard, Shane Loretz, Stephen Brawner, ahcorde, brawner

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 07 Dec 2020 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.0.1-2jammy) jammy; urgency=high

  * Bump QD to level 3 and updated QD (#44 <https://github.com/ros2/rcl_logging/issues/44>)
  * Added Doxyfile and fixed related warnings (#42 <https://github.com/ros2/rcl_logging/issues/42>)
  * Contributors: Alejandro Hernández Cordero

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 20 Jul 2020 16:00:00 -0000

ros-iron-rcl-logging-spdlog (2.0.0-2jammy) jammy; urgency=high

  * Use new package with rcl logging interface (#41 <https://github.com/ros2/rcl_logging/issues/41>)
  * Increased test coverage (#40 <https://github.com/ros2/rcl_logging/issues/40>)
  * Add Security Vulnerability Policy pointing to REP-2006.
  * Rename Quality_Declaration.md -> QUALITY_DECLARATION.md
  * Contributors: Chris Lalancette, Scott K Logan

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 Jun 2020 16:00:00 -0000



=== debian/control ===
Source: ros-iron-rcl-logging-spdlog
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libspdlog-dev, ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-performance-test-fixture <!nocheck>, ros-iron-rcl-logging-interface, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-spdlog-vendor, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-rcl-logging-spdlog
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libspdlog-dev, ros-iron-rcl-logging-interface, ros-iron-rcpputils, ros-iron-rcutils, ros-iron-spdlog-vendor, ros-iron-ros-workspace
Description: Implementation of rcl_logging API for an spdlog backend.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-rcl-logging-spdlog//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
